% note there is a BUG in res.awk, assuming it is match length N=3 always.
% to correct for this manually when transfering results from results.txt to
% here multiply all ratings by sqrt(3)/sqrt(N)

noise = [0 .005    .015   .02     NaN  .04    .06];
ml = [1 3 5 7 11 23];
%    adv2    adv    int2   i_b    int     beg
eq=    [
  0 .00157  .00748 .01117 .01486 .02660  .03856 %1
  0 .001424 .00767 .01178 .01868 .02920  .04616 %3
  0 .001345 .00759 .01144 .02022 .02969  .04704 %5
  0 .001326 .00748 .01123 .01970 .02872  .04688 %7
  0 .001312 .00742 .01114 .02060 .02878  .04606 %11
  0 .001299 .0073  .01110 .01939 .02824  .04513 %23
  ];
r =    [
  0  33     142     214    331   549    878  %1
  0  38     155     234    368   584    860  %3
  0  33     166     242    420   633    1025 %5
  0  30     181     275    452   643    1104 %7
  0  34     207     301    567   784    1247 %11
  0  46     281     419    723   1047   1588 %23
  ]; 
rmin=  [
  0  37     132     202    305   528    839  %1
  0  29     143     221    341   559    815  %3
  0  24     155     229    394   605    956  %5
  0  21     170     262    426   615    1041 %7
  0  25     196     288    539   750    1162 %11
  0  25     269     403    688   996    1440 %23
  ];
rmax=  [
  0  45     153     226    358   571    920  %1
  0  47     167     247    395   610    907  %3
  0  42     177     254    447   662    1080 %5
  0  39     192     288    479   672    1175 %7
  0  43     218     314    596   820    1347 %11
  0  55     294     435    761   1104   1793 %23
  ];

% verification points: 
%2ply-0ply 3pt
eq_ver =    [.0026];%3
r_ver =     [ 58];%3
rmin_ver =  [ 32];%3
rmax_ver =  [ 84];%3

eq_i=0:.001:.04616;

interpstr = 'linear';

figure(1)
clf
hold on
cols = {'k','b','g','r','c','m'};
cols2 = {'k:','b:','g:','r:','c:','m:'};

for k=1:length(ml)
  eq_m = eq(k,:);
  mlen = ml(k);
  % NB correct for BUG in res.awk here
  BUGFACTOR = sqrt(3)/sqrt(mlen);
  r_m = BUGFACTOR*r(k,:);
  r_i=interp1(eq_m,r_m,eq_i,interpstr);
  figure(1)
  plot(eq_i,r_i,cols{k});
  r_i_formula = (23681/mlen + 11971)*eq_i;
  plot(eq_i,r_i_formula,cols2{k});
end
tstr = sprintf('%d',mlen);
xlabel 'DEPD'
ylabel 'R and 90'  
hold on
title 'R versus DEPD curves'
legend('1','3','5','7','11','23',0);
axis tight
grid on

%return;

% coeff of linear lsq fit R = a*DEPD
a = zeros(length(ml),1);

for k=1:length(ml)
  eq_m = eq(k,:);
  mlen = ml(k);
  % NB correct for BUG in res.awk here
  BUGFACTOR = sqrt(3)/sqrt(mlen);
  r_m = BUGFACTOR*r(k,:);
  rmin_m=BUGFACTOR*rmin(k,:);
  rmax_m=BUGFACTOR*rmax(k,:);
  r_i=interp1(eq_m,r_m,eq_i,interpstr);
  rmin_i=interp1(eq_m,rmin_m,eq_i,interpstr);
  rmax_i=interp1(eq_m,rmax_m,eq_i,interpstr);
  
  figure(k+1)
  clf
  plot(eq_i,r_i,'r');
  hold on
  plot(eq_i,rmin_i,'k');
  plot(eq_i,rmax_i,'k');
  plot(eq_m,r_m,'O');
  if k==2
	plot(eq_ver,r_ver,'X');
  end
  % minimize error of sum(R2) with linear fit
  n = length(eq_m);
  q = eq_m(2:n) .* r_m(2:n);
  Q = sum(q);
  Q2 = eq_m(2:n) * eq_m(2:n)';
  a(k) = Q/Q2;
  r_linear = a(k) * eq_i;
  plot(eq_i,r_linear,'g');
  axis tight
  grid on
  tstr = sprintf('matchlength = %d, R=%2.2f*DEPD*1000',mlen,a(k)/1000);
  title(tstr);
  xlabel 'DEPD'
  ylabel 'R, 90 confidence interval, and linear fit'
end

% visually 
figure(length(ml)+2)
clf
a = a';
an = a .* ml;
plot(ml,an);
hold on
plot(ml,an,'O');
grid on
axis tight
xlabel matchlength
ylabel Na(N)


% minimize error of sum(R2) with linear fit
% fit with alpha*N + beta, leave out 1pt results
ml2 = ml(1:length(ml));
an2 = an(1:length(an));
q = an2 .* ml2;
Q = sum(q)
Q2 = ml * ml';
X = sum(ml);
Y = sum(an2);
alpha = (Y*X-length(ml2)*Q)/(X*X-length(ml2)*Q2);
beta = (Y-alpha*X)/length(ml2);
ml_i = 1:max(ml2);
an_lin = alpha*ml_i + beta;
plot(ml_i,an_lin,'r');
tstr = sprintf('Na(N) fit by %7.2f*N+%7.2f',alpha,beta);
title(tstr);